#include "trucs_sockets.h"
#include <string>
#include <iostream>
#include <cstdlib>
#include <WinSock2.h>

using std::string;
using std::cerr;
using std::endl;
using std::exit;

bool EstInvalide(const socket_t sck)
   { return sck == INVALID_SOCKET; }

bool EstErreur(const socket_operation_t op)
   { return op == SOCKET_ERROR; }

short normaliser(short n)
   { return htons(n); }
short denormaliser(short n)
   { return ntohs(n); }
long normaliser(long n)
   { return htonl(n); }
long denormaliser(long n)
   { return ntohl(n); }

void ChargerSockets()
{
   const long VERSION_DEMANDEE = MAKEWORD(2,2);
   WSAData configWinsock;
   if (WSAStartup (VERSION_DEMANDEE, &configWinsock) != 0)
      throw erreur("Dmarrage");
}

void DechargerSockets()
   { WSACleanup(); }

socket_t CreerSocket()
{
   socket_t sck =
      socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
   if (sck == INVALID_SOCKET)
      throw erreur("Cration");
   return sck;
}

void FermerSocket(const socket_t sck)
{
   shutdown(sck, SD_BOTH);
   closesocket(sck);
}

void Connecter
   (socket_t sck, const string &adresse, const short port)
{
   sockaddr_in dest = { 0 };
   dest.sin_family= AF_INET;
   dest.sin_addr.s_addr=
      inet_addr(adresse.c_str());
   dest.sin_port = port;
   socket_operation_t resultat = connect
      (sck, reinterpret_cast<const sockaddr*>(&dest),
            sizeof(sockaddr_in));
   if (EstErreur(resultat))
      throw erreur("Connexion");
}

string Recevoir(const socket_t sck, const char FIN)
{
   const int TAILLE_TAMPON = 64; // arbitraire
   char tampon[TAILLE_TAMPON];
   string message_recu;
   bool reception_completee = false;
   do
   {
      socket_operation_t n =
         recv(sck, tampon, TAILLE_TAMPON, 0);
      if (EstErreur(n))
         throw (erreur("Rception"));
      message_recu.append(tampon, tampon + n);
      if (tampon[n-1] == FIN)
         reception_completee = true;
   }
   while (!reception_completee);
   return message_recu.substr(0, message_recu.size()-1);
}

void Envoyer(const socket_t sck, string msg, const char FIN)
{
   msg += FIN;
   while (!msg.empty())
   {
      socket_operation_t plus_recent =
         send(sck, msg.c_str(), static_cast<int>(msg.size()), 0);
      if (EstErreur(plus_recent))
         throw erreur("Envoi");
      msg = msg.substr(plus_recent);
   }
}

void ReserverPort(const socket_t sck, const short port)
{
   sockaddr_in nom = { 0 };
   nom.sin_family = AF_INET;
   nom.sin_port = port;
   socket_operation_t resultat = bind
      (sck, reinterpret_cast<const sockaddr*> (&nom),
            sizeof (sockaddr_in));
   if (EstErreur(resultat))
   {
      cerr << "Port " << htons(port) << ", ";
      throw erreur("Obtention");
   }
   // Crer la file dattente pour demandes de connexion
   int taille_file_attente = 16; // arbitraire
   if (EstErreur(listen(sck, taille_file_attente)))
      throw erreur("Crer file d'attente");
}

socket_t AccepterClient(const socket_t srv)
{
   sockaddr_in homologue = { 0 };
   int taille_homologue= sizeof(sockaddr_in);
   socket_t sck =
      accept(srv, reinterpret_cast<sockaddr *>(&homologue),
              &taille_homologue);
   if (EstInvalide(sck))
      throw erreur("Accepter connexion");
   return sck;
}
