#ifndef TRUCS_SOCKETS_H
#define TRUCS_SOCKETS_H

#include <string>
#include <winsock2.h>

typedef SOCKET socket_t;
bool EstInvalide(const socket_t);

typedef int socket_operation_t;
bool EstErreur(const socket_operation_t);

short normaliser(short);
short denormaliser(short);
long normaliser(long);
long denormaliser(long);

#include <iosfwd>

struct erreur
{
   const char *msg;
   int code;
   erreur(const char *msg, int code = WSAGetLastError())
      : msg(msg), code(code)
   {
   }
   friend std::ostream& operator<<
      (std::ostream &os, const erreur &err)
   {
      return os << "Erreur: " << err.msg << ", code " << err.code;
   }
};

void ChargerSockets();

void DechargerSockets();

socket_t CreerSocket();

void FermerSocket(const socket_t);

void Connecter(socket_t, const std::string &adresse, const short port);

std::string Recevoir(const socket_t, const char FIN);

void Envoyer(const socket_t, std::string msg, const char FIN);

void ReserverPort(const socket_t sck, const short port);

socket_t AccepterClient(const socket_t);

#endif
